/*
TASK:F
LANG:C++
*/
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<queue>
using namespace std;
int n, m;
class edge
{
public:
	int b, e;
	double l;
	edge(){b=0;e=0;}
	edge(int f,int t, double hh){b=f;e=t;l=hh;}
	bool operator < (const edge &t) const{
		return l<t.l;
	}
};

double a[1000][1000];
double b[1000][1000];
int parent[1000];
double lenth[1000];
queue<int> q;
edge kk[4000];
int used[1000]={0};
void bfs(int v)
{
	int i;
	int cv;
	used[v]=1;
	q.push(v);
	while(!q.empty())
	{
		cv=q.front();
		q.pop();
		for(i=0;i<n;i++)
			if(b[cv][i]&&!used[i])
			{
				used[i]=1;
				q.push(i);
				lenth[i]=lenth[cv]+b[cv][i];
			}
	}
}
void init()
{
	int i, p,k;
	double t;
	freopen("f.in","r",stdin);
	scanf("%d %d",&n,&m);
	for(i=0;i<m;i++)
	{
		scanf("%d %d %lf",&p,&k,&t);
		a[p-1][k-1]=t;
		a[k-1][p-1]=t;
		kk[i]=edge(p-1,k-1,t);
	}
	for(i=0;i<n;i++)
		parent[i]=i;
}
void solve()
{
	int i,j;
	int it=0;
	double max=0;
	int maxi;
	int prev1,prev2;
	sort(kk,kk+m);
	for(i=0;i<n-1;i++)
	{
		while(true)
		{
			if((parent[kk[it].b]!=parent[kk[it].e])||(parent[kk[it].b]!=-1)){break;}
			it++;
		}
		prev1=parent[kk[it].b];
		prev2=parent[kk[it].e];
		b[kk[it].b][kk[it].e]=kk[it].l;
		b[kk[it].e][kk[it].b]=kk[it].l;
		it++;
		for(j=0;j<n;j++)
		{
			if(parent[j]==prev2) parent[j]=prev1;
		}

	}
	bfs(0);
	for(i=0;i<n;i++)
		if(max<lenth[i]){max=lenth[i];maxi=i;}
	memset(lenth,0,sizeof(lenth));
	memset(used,0,sizeof(used));
	bfs(maxi);
	max=0;
	for(i=0;i<n;i++)
	{
		if(max<lenth[i]){max=lenth[i];}
	}
	printf("%.4lf\n",max/2);
}
int main()
{
	init();
	solve();
	return 0;
}
