/*
TASK:e
LANG:C++
*/

#include <cstdio>
#include <climits>

#include <ctime>

typedef signed int ind;
typedef unsigned int plval;

void read_ind(ind& n) {std::scanf("%d", &n);}
void write_ind(const ind& n) {std::printf("%d", n);}
void read_plval(plval& n) {std::scanf("%u", &n);}
void write_plval(const plval& n) {std::printf("%u", n);}
void write(const char* s) {std::printf("%s", s);}

const plval unknown = UINT_MAX;

const ind max_n = 200;
const plval max_b = 2000;

plval m[max_n+1][max_b+1];

ind init()
{
	for (ind i = 0; i <= max_n; i++)
		for (plval j = 0; j <= max_b; j++)
			m[i][j] = unknown;

	return 0;
}

const ind __strt = init();

int main()
{
	ind n; plval b;
	read_ind(n); read_plval(b);
	std::clock();

	for (plval i = 0; i <= b; i++)
		m[0][i] = 0;

	for (ind i = 0; i <= n; i++)
		m[i][i] = (i*(i-1))/2;

	for (plval j = 0; j <= b; j++)
		for (ind i = 1; i <= n && i < (ind)j; i++)
		{
			plval max = 0;
			for (plval k = j-1; k >= (plval)i; k--)
			{
				plval curr = (j-k)*k + m[i-1][k];
				if (max < curr)
					max = curr;
			}
			m[i][j] = max;
		}

	write_plval(m[n][b]);
	write("\n");

	//std::printf("%.2lf\n", std::clock()/(double)CLOCKS_PER_SEC);

	return 0;
}
