/*
TASK: F
LANG: C++
*/
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <queue>
#define MAXN 1005
#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
using namespace std;

int n,m;
int c[MAXN];
int a[MAXN][MAXN];
double b[MAXN][MAXN];
double g[MAXN][MAXN];
double d[MAXN];
double res;
int marked[MAXN];


struct cmp
{
	bool operator() (const pair<double,int> a,const pair<double,int> b) const
	{
		return a.first>b.first;
	}
};

priority_queue< pair<double,int>,vector< pair<double,int> >,cmp > heap;

	
int solve (int v1,int v2,double len,double z)
{
	int i;
	double l,r;
	r=len;
	l=0;
	for (i=1;i<=n;i++)
	{
		if (z<g[v1][i] && z<g[v2][i]) return 0;		
		if (2*z+1e-8>=g[v1][i]+g[v2][i]+len) continue;
		if (z<g[v1][i]) 
			l=max(len-(z-g[v2][i]),l);
		else
			r=min(r,z-g[v1][i]);		

	}
	if (r+1e-8>=l)
	{
		res=min(res,z);
		return 1;
	}
	return 0;
}


int main ()
{
	int i,j,k,p,q,w,v1,v2;
	double pom,l,r,med;
	FILE *f1,*f2;
//	f1=fopen("C:\\f.in","r");	
//	f2=fopen("C:\\f.out","w");	
	f1=stdin;
	f2=stdout;
	fscanf(f1,"%d%d",&n,&m);
	for (i=1;i<=m;i++)
	{
		fscanf(f1,"%d%d%lf",&p,&q,&pom);
		a[p][c[p]]=q;
		a[q][c[q]]=p;
		b[p][c[p]]=pom;
		b[q][c[q]]=pom;
		c[p]++;
		c[q]++;
	}	
	for (w=1;w<=n;w++)
	{
		for (i=0;i<=n;i++)
			d[i]=1e9;
		memset(marked,0,sizeof(marked));
		d[w]=0;		
		heap.push(make_pair(0,w));
		while (!heap.empty())
		{
			k=heap.top().second;
			pom=heap.top().first;
			heap.pop();
			if (marked[k]==1) continue;
			marked[k]=1;
			for (j=0;j<c[k];j++)
				if (marked[a[k][j]]==0 && d[a[k][j]]>d[k]+b[k][j])
				{
					d[a[k][j]]=d[k]+b[k][j];
					heap.push(make_pair(d[a[k][j]],a[k][j]));
				}
		}
		for (i=1;i<=n;i++)
			g[w][i]=d[i];
	}
	res=1e9;
	for (i=1;i<=n;i++)
	{
		pom=0;
		for (j=1;j<=n;j++)
			pom=max(pom,g[i][j]);				
		res=min(res,pom);
	}	
	for (i=1;i<=n;i++)
		for (j=0;j<c[i];j++)
		{
			v1=i;
			v2=a[i][j];								
			l=0;
			r=1e8;
			while (r-l>1e-8)
			{
				med=(l+r)/2.0;
				if (solve(v1,v2,b[i][j],med))
					r=med;
				else
					l=med;
			}			
		
		}
	fprintf(f2,"%.4lf\n",res);
	return 0;
}