/*
TASK:E
LANG:C++
*/

#include <stdio.h>
#include <algorithm>

using namespace std;

#define IN "e.in"
#define OUT "e.out"

#define MAXM 256
#define MAXN 2048
#define MAX (2<<28)


int dp[MAXM][MAXN];

inline int min (int a,int b) {if (a < b) return a;else return b;}
inline int max (int a,int b) {if (a > b) return a;else return b;}

int solve (int n, int b) {
	int & ret = dp[n][b];
	if ( ret != -1) return ret;
	ret = MAX;

	if (n == 0) {
		ret = b*b;
		return ret;
	}

	for (int k=1; k <= b-k && (b-k) - (n-1) >= 0; k++) {
		int t = solve(n-1,b-k);
		ret = min (ret, t + k*k);
	}

	return ret;
}


int main () {
//	freopen(IN,"r",stdin);
//	freopen(OUT,"w",stdout);

	int n,b;

	scanf("%d%d",&n,&b);

	for (int i=0; i<MAXM; i++) 
		for (int j=0; j<MAXN; j++)
			dp[i][j] = -1;




	int ans = (b*b - solve(n,b) ) / 2;
	printf("%d\n",ans);
	
	return 0;
}
